/*
 * Copyright (C) 2022 Das Land Schleswig-Holstein vertreten durch den
 * Ministerpräsidenten des Landes Schleswig-Holstein
 * Staatskanzlei
 * Abteilung Digitalisierung und zentrales IT-Management der Landesregierung
 *
 * Lizenziert unter der EUPL, Version 1.2 oder - sobald
 * diese von der Europäischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie dürfen dieses Werk ausschließlich gemäß
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 * https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWÄHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrücklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschränkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
package de.ozgcloud.operator.keycloak.group;

import org.apache.commons.lang3.reflect.FieldUtils;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.keycloak.admin.client.Keycloak;
import org.keycloak.admin.client.KeycloakBuilder;
import org.keycloak.representations.idm.GroupRepresentation;
import org.mapstruct.factory.Mappers;
import org.mockito.InjectMocks;
import org.mockito.Spy;
import org.springframework.test.context.junit.jupiter.SpringExtension;

import lombok.extern.java.Log;

@Disabled("Should only be used manually")
@Log
@ExtendWith(SpringExtension.class)
class KeycloakLivelTest {
	
	private static final String NAMESPACE = "by-torsten-ozgcloud-keycloak-operator-dev";

	@Spy
	@InjectMocks
	private KeycloakGroupRemoteService remoteService;

	@Spy
	@InjectMocks
	private KeycloakGroupService service;

	@Spy
	private KeycloakGroupMapper mapper = Mappers.getMapper(KeycloakGroupMapper.class);

	@Test
	void testReal() throws IllegalAccessException {
		Keycloak kc = KeycloakBuilder.builder()
				.serverUrl("https://sso.dev.by.ozg-cloud.de")
				.realm("master")
				.username("admin")
				.password(" ")
				.clientId("admin-cli")
				.build();

		FieldUtils.writeField(remoteService, "keycloak", kc, true);

		remoteService.createGroup(createGroup(), NAMESPACE);
		log.info("Hase: " + remoteService.getGroupByName("hase", NAMESPACE));
		log.info("Maus: " + remoteService.getGroupByName("maus", NAMESPACE));

		service.createGroup(OzgCloudKeycloakGroupSpec.builder().name("Fuchs").build(), NAMESPACE);
	}

	private GroupRepresentation createGroup() {
		GroupRepresentation realm = new GroupRepresentation();
		realm.setName("hase");
		return realm;
	}
}
